#ifndef _XML_NAMES_H_
#define _XML_NAMES_H_

namespace xmlnames {

// text-fsa
const char * const TEXT_FSA_ELEM = "text-fsa";
const char * const SIZE_ATTR = "sz";

// text-uchart
const char * const TEXT_UCHART_ELEM = "text-uchart";

const char * const TEXT_CHART_ELEM = "text-chart";

// uchart
const char * const CHART_ELEM = "chart";
const char * const UCHART_ELEM = "uchart";

const char * const TABLE_ELEM = "tab";
const char * const NODE_ELEM = "node";

const char * const MATCH_ELEM = "match";
const char * const SYNTAGM_ELEM = "syntagm";
const char * const WEIGHT_ATTR = "w";
const char * const PATH_ATTR = "path";

const char * const FEATSTRUCT_ELEM = "fs";
const char * const BOTTOM_ATTR = "bottom";
const char * const ENTRY_ATTR  = "e";

const char * const FSNODE_ELEM = "fsnode";
const char * const TYPE_ATTR = "type";
const char * const REF_ATTR = "ref";


// sentence fsa
const char * const SENTENCE_FSA_ELEM = "sfsa";

const char * const TEXT_ELEM = "txt";

const char * const STATE_ELEM = "q";
const char * const ID_ATTR    = "id";
const char * const FINAL_ATTR = "f";
const char * const POS_ATTR   = "pos";

const char * const TRANS_ELEM = "tr";
const char * const LABEL_ATTR = "lbl";
const char * const TO_ATTR = "to";

// ugrammar
const char * const UGRAMMAR_ELEM = "ugrammar";
const char * const MAIN_ATTR = "main";

// rtn_grammar
const char * const RTN_GRAMMAR_ELEM = "rtn-grammar";
const char * const RTN_PATTERN_ELEM = "rtn-pattern";

// wrtn grammar

const char * const WRTN_GRAMMAR_ELEM = "wrtn-grammar";
const char * const WRTN_PATTERN_ELEM = "wrtn-pattern";
const char * const WRTN_OUT_ELEM = "out";
const char * const WRTN_WEIGHT_ATTR = "w";

// fst

const char * const FST_ELEM = "fst";

const char * const PROP_ELEM = "p";

const char * const GENERIC_FST_ELEM = "gfst";
const char * const STRING_FST_ELEM = "string_fst";

const char * const STRING_OUTPUT_ELEM = "str_out";
const char * const INF_ELEM = "inf";
const char * const ELEM_ELEM = "e";

const char * const IN_ELEM = "in";
const char * const OUT_ELEM = "out";
const char * const FINAL_OUTPUTS_ELEM = "f-out";


// usyntagm pattern
const char * const USYNTAGM_PATTERN_ELEM = "upat";

const char * const SUBCALL_ELEM = "scall";
const char * const EPSILON_ELEM = "epsilon";


// lexic
const char * const LEXIC_ELEM = "lexic";

// lexmask
const char * const LEXMASK_ELEM = "lex";

const char * const VOID_ELEM = "void";

const char * const FORM_ELEM = "form";
const char * const LEMMA_ELEM = "lem";
const char * const POS_ELEM = "pos";

const char * const FEAT_ELEM = "f";
const char * const NEG_ATTR  = "neg";
const char * const NAME_ATTR = "n";
const char * const VAL_ATTR = "v";

// featstruct

const char * const FS_ELEM = "fs";
const char * const SYM_ELEM = "sym";


};

#endif
