#ifndef _WRTN_TRANSDUCT_H_
#define _WRTN_TRANSDUCT_H_

#include <iostream>

enum trans_mode_type {
  MERGE, REPLACE, IGNORE
};

enum trans_output_type {
  TEXT, HTML
};

class sentence_fsa;
class wrtn_parser;

/**
 * @brief function wrtn_transduct parses a sentence fsa with a wrtn containing transductions
 * @param fsa sentence fsa
 * @param gram parser
 * @param os outpur stream
 * @param transmode type of transduction (merging, replacing, ...)
 * @param outputmode type of output (text, html)
 */

int wrtn_transduct(sentence_fsa & fsa, wrtn_parser & gram,
                  std::ostream & os, trans_mode_type transmode, trans_output_type outputmode);


#endif
