#ifndef _LINGUISTICDEFINITION_FORMATTER_H_
#define _LINGUISTICDEFINITION_FORMATTER_H_

namespace LinguisticDefinition {

  /**
   * A formatter handles input and output to external data sources.
   *
   * A LingDef object may for example be created from an XML file, or a
   * LingFeatures object from a serialized string representation.
   *
   * Formatters have no special relationship with the objects that they
   * create/populate. Anything a formatter can do, you can do "manually" with
   * the public member functions of that object.
   *
   * This way, the structure is separated from the representation. It is also
   * easier to add new formats, and select a subset of the functionality.
   */
  class Formatter {
  public:

    /**
     *
     */
    Formatter();

  private:
  };

}

#endif //_LINGUISTICDEFINITION_FORMATTER_H_
